<div class="card">
  <div class="card-divider">
    <h2 class="card-title"><%= title %></h2>
  </div>

  <div class="card-section">
    <div class="row column">
      <%= form.translated :text_field, :name, autofocus: true %>
      <%= form.number_field :weight %>

      <% if form.object.settings? %>
        <fieldset class="global-settings">
          <div class="card">
            <div class="card-divider">
              <legend><%= t ".global_settings" %></legend>
            </div>
            <div class="card-section">
              <%= form.fields_for :settings, form.object.settings do |settings_fields| %>
                <%= render partial: "decidim/admin/components/settings_fields",
                           locals: {
                             form: settings_fields,
                             component: @component,
                             settings_name: "global",
                             tabs_prefix: "global-settings"
                           } %>
              <% end %>
            </div>
          </div>
        </fieldset>
      <% end %>

      <% if current_participatory_space.has_steps? %>
        <fieldset class="step-settings">
          <div class="card">
            <div class="card-divider">
              <legend><%= t ".step_settings" %></legend>
            </div>
            <div class="card-section">
              <% current_participatory_space.steps.each do |step| %>
                <fieldset class="step-settings-<%= step.id %>">
                  <legend><%= step.position + 1 %>. <%= translated_attribute step.title %></legend>
                  <% step_settings = form.object.step_settings[step.id.to_s] %>

                  <%= form.fields_for :step_settings, nil do |settings_fields| %>
                    <%= settings_fields.fields_for step.id.to_s, step_settings do |settings_fields| %>
                      <%= render partial: "decidim/admin/components/settings_fields",
                                 locals: {
                                   form: settings_fields,
                                   component: component,
                                   settings_name: "step",
                                   tabs_prefix: "step-#{step.id}-settings"
                                 } %>
                    <% end %>
                  <% end %>
                </fieldset>
              <% end %>
            </div>
          </div>
        </fieldset>
      <% elsif form.object.default_step_settings? %>
        <fieldset class="default-step-settings">
          <div class="card">
            <div class="card-divider">
              <legend><%= t ".default_step_settings" %></legend>
            </div>
            <div class="card-section">
              <%= form.fields_for :default_step_settings, form.object.default_step_settings do |settings_fields| %>
                <%= render partial: "decidim/admin/components/settings_fields",
                           locals: {
                             form: settings_fields,
                             component: @component,
                             settings_name: "step",
                             tabs_prefix: "default-step-settings"
                           } %>
              <% end %>
            </div>
          </div>
        </fieldset>
      <% end %>
    </div>
  </div>
</div>

<%= javascript_include_tag "decidim/admin/form" %>

<script type="text/javascript">
  function disableClick(check1, check2, field1, field2) {
    if (check1.is(":checked")) {
      check2.prop("disabled", true);
      // When the checkbox is followed by an input
      if (field2) {
        disableField(field2)
      }
    } else if (check2.is(":checked")) {
      check1.prop("disabled", true);
      // When the checkbox is followed by an input
      if (field1) {
        disableField(field1)
      }
    }
  }

  function switchDisabling(check1, check2, field1, field2) {
    check1.change(function () {
      if ($(this).is(":checked")) {
        check2.prop("disabled", true);
        // When the checkbox is followed by an input
        if (field2) {
          disableField(field2)
        }
      } else {
        $(this).prop("disabled", false);
        check2.prop("disabled", false);
        if (field2 && field1) {
          enableField(field2)
          enableField(field1)
        }
      }
    })
  }

  function disableOtherField(field, actionCheck) {
    if (actionCheck.is(":checked")) {
      disableField(field)
    } else {
      enableField(field)
    }
    actionCheck.change(function () {
      if (actionCheck.is(":checked")) {
        disableField(field)
      } else {
        enableField(field)
      }
    });
  }

  function disableField(field) {
    field.prop("disabled", true);
  }

  function enableField(field) {
    field.prop("disabled", false);
  }

  $(document).ready(function () {
    // PROPOSAL
    var participatory_space_id = <%= current_participatory_space.id %>;
    var $supports = $('input[name="component[step_settings][' + participatory_space_id + '][votes_enabled]"]')
    var $votes = $('input[name="component[step_settings][' + participatory_space_id + '][votes_weight_enabled]"]')
    disableClick($supports, $votes, false, false)
    switchDisabling($supports, $votes, false, false)
    switchDisabling($votes, $supports, false, false)
    // BUDGET
    var $perBudget = $('input[name="component[settings][vote_per_budget]"]')
    var $perProject = $('input[name="component[settings][vote_per_project]"]')
    var $BudgetSumField = $('input[name="component[settings][total_budget]"]')
    var $projectNumberField = $('input[name="component[settings][total_projects]"]')
    var $voteTreshold = $('input[name="component[settings][vote_threshold_percent]"]')
    switchDisabling($perBudget, $perProject, $BudgetSumField, $projectNumberField)
    switchDisabling($perProject, $perBudget, $projectNumberField, $BudgetSumField)
    disableClick($perBudget, $perProject, $BudgetSumField, $projectNumberField)
    disableClick($perProject, $perBudget, $projectNumberField, $BudgetSumField)
    disableOtherField($voteTreshold, $perProject)
  });
</script>
